;--- include file created by h2incx v0.99.19 (copyright 2005-2006 japheth)
;--- source file: C:\MASM Projects\lij1\mysql.h, last modified: 1/18/2008 16:57
;--- cmdline used for creation: mysql.h

include mysql_version.inc
include mysql_com.inc
include mysql_time.inc
include typelib.inc
include my_list.inc

;SCRAMBLE_LENGTH = 20

IS_PRI_KEY macro n
	exitm <( ( n )  and  PRI_KEY_FLAG ) >
	endm
IS_NOT_NULL macro n
	exitm <( ( n )  and  NOT_NULL_FLAG ) >
	endm
IS_BLOB macro n
	exitm <( ( n )  and  BLOB_FLAG ) >
	endm
IS_NUM macro t
	exitm <( ( t ) <= FIELD_TYPE_INT24 || ( t ) == FIELD_TYPE_YEAR || ( t ) == FIELD_TYPE_NEWDECIMAL ) >
	endm
IS_NUM_FIELD macro f
	exitm <( ( f ) -> flags  and  NUM_FLAG ) >
	endm
INTERNAL_NUM_FIELD macro f
	exitm <( ( ( f ) -> type <= FIELD_TYPE_INT24 && ( ( f ) -> type != FIELD_TYPE_TIMESTAMP || ( f ) -> length == 14 || ( f ) -> length == 8 ) ) || ( f ) -> type == FIELD_TYPE_YEAR ) >
	endm
IS_LONGDATA macro t
	exitm <( ( t ) >= MYSQL_TYPE_TINY_BLOB && ( t ) <= MYSQL_TYPE_STRING ) >
	endm
MYSQL_FIELD	struct 
name_	DWORD	?
org_name	DWORD	?
table	DWORD	?
org_table	DWORD	?
database	DWORD	?
catalog	DWORD	?
def	DWORD	?
length_	DWORD	?
max_length	DWORD	?
name_length	DWORD	?
org_name_length	DWORD	?
table_length	DWORD	?
org_table_length	DWORD	?
db_length	DWORD	?
catalog_length	DWORD	?
def_length	DWORD	?
flags	DWORD	?
decimals	DWORD	?
charsetnr	DWORD	?
;type_	enum_field_types	?
type_	dword	?
MYSQL_FIELD	ends

MYSQL_ROW typedef ptr ptr SBYTE
MYSQL_FIELD_OFFSET typedef DWORD
MYSQL_COUNT_ERROR	EQU	<(  not  ( my_ulonglong ) 0 )>
ER_WARN_DATA_TRUNCATED	EQU	<WARN_DATA_TRUNCATED>
MYSQL_ROWS	struct 
	next DWORD ?
	data MYSQL_ROW ?
	length_	DWORD ?
MYSQL_ROWS	ends

;MYSQL_ROW_OFFSET typedef ptr MYSQL_ROWS
	;include my_alloc.inc
;EMBEDDED_QUERY_RESULT typedef embedded_query_result

MYSQL_DATA	struct 
	rows	dword	?
	fields	DWORD	?
	data	MYSQL_ROWS <>
	_alloc	MEM_ROOT <>
	embedded_info DWORD ?
MYSQL_DATA	ends

mysql_option typedef DWORD
MYSQL_OPT_CONNECT_TIMEOUT = 0
MYSQL_OPT_COMPRESS = 1
MYSQL_OPT_NAMED_PIPE = 2
MYSQL_INIT_COMMAND = 3
MYSQL_READ_DEFAULT_FILE = 4
MYSQL_READ_DEFAULT_GROUP = 5
MYSQL_SET_CHARSET_DIR = 6
MYSQL_SET_CHARSET_NAME = 7
MYSQL_OPT_LOCAL_INFILE = 8
MYSQL_OPT_PROTOCOL = 9
MYSQL_SHARED_MEMORY_BASE_NAME = 10
MYSQL_OPT_READ_TIMEOUT = 11
MYSQL_OPT_WRITE_TIMEOUT = 12
MYSQL_OPT_USE_RESULT = 13
MYSQL_OPT_USE_REMOTE_CONNECTION = 14
MYSQL_OPT_USE_EMBEDDED_CONNECTION = 15
MYSQL_OPT_GUESS_CONNECTION = 16
MYSQL_SET_CLIENT_IP = 17
MYSQL_SECURE_AUTH = 18
MYSQL_REPORT_DATA_TRUNCATION = 19
MYSQL_OPT_RECONNECT = 20
MYSQL_OPT_SSL_VERIFY_SERVER_CERT = 21

st_mysql_options	struct 
connect_timeout	DWORD	?
;read_timeout	unsigned unsigned uns	?
;write_timeout	unsigned unsigned unsigned uns	?
read_timeout	dword	?
write_timeout	dword	?
port	DWORD	?
;protocol	unsigned unsigned uns	?
protocol	dword	?
client_flag	DWORD	?
host	DWORD	?
user	DWORD	?
password	DWORD	?
unix_socket	DWORD	?
database	DWORD	?
init_commands DWORD ?
my_cnf_file	DWORD	?
my_cnf_group	DWORD	?
charset_dir	DWORD	?
charset_name	DWORD	?
ssl_key	DWORD	?
ssl_cert	DWORD	?
ssl_ca	DWORD	?
ssl_capath	DWORD	?
ssl_cipher	DWORD	?
shared_memory_base_name	DWORD	?
max_allowed_packet	DWORD	?
;use_ssl	my_bool	?
;compress	my_bool	?
;named_pipe	my_bool	?
;rpl_probe	my_bool	?
;rpl_parse	my_bool	?
;no_master_reads	my_bool	?
use_ssl	dword	?
compress	dword	?
named_pipe	dword	?
rpl_probe	dword	?
rpl_parse	dword	?
no_master_reads	dword	?
;if 0 eq defined(CHECK_EMBEDDED_DIFFERENCES) OR defined(EMBEDDED_LIBRARY)
;separate_thread	my_bool	?
;endif 
methods_to_use	mysql_option	?
client_ip	DWORD	?
;secure_auth	my_bool	?
;report_data_truncation	my_bool	?
secure_auth	dword	?
report_data_truncation	dword	?
protost_mysql_options_local_infile_init typedef proto  :ptr ptr ,:ptr SBYTE,:ptr 
pst_mysql_options_local_infile_init typedef ptr protost_mysql_options_local_infile_init
local_infile_init	pst_mysql_options_local_infile_init	?
;protost_mysql_options_local_infile_read typedef proto  :ptr ,:ptr SBYTE,:unsigned
pst_mysql_options_local_infile_read typedef ptr protost_mysql_options_local_infile_read
local_infile_read	pst_mysql_options_local_infile_read	?
protost_mysql_options_local_infile_end typedef proto  :ptr 
pst_mysql_options_local_infile_end typedef ptr protost_mysql_options_local_infile_end
local_infile_end	pst_mysql_options_local_infile_end	?
;protost_mysql_options_local_infile_error typedef proto  :ptr ,:ptr SBYTE,:unsigned
pst_mysql_options_local_infile_error typedef ptr protost_mysql_options_local_infile_error
local_infile_error	pst_mysql_options_local_infile_error	?
local_infile_userdata	DWORD	?
st_mysql_options	ends

mysql_status typedef DWORD
MYSQL_STATUS_READY = 0
MYSQL_STATUS_GET_RESULT = 1
MYSQL_STATUS_USE_RESULT = 2

mysql_protocol_type typedef DWORD
MYSQL_PROTOCOL_DEFAULT = 0
MYSQL_PROTOCOL_TCP = 1
MYSQL_PROTOCOL_SOCKET = 2
MYSQL_PROTOCOL_PIPE = 3
MYSQL_PROTOCOL_MEMORY = 4

mysql_rpl_type typedef DWORD
MYSQL_RPL_MASTER = 0
MYSQL_RPL_SLAVE = 1
MYSQL_RPL_ADMIN = 2

MY_CHARSET_INFO	struct 
number	DWORD	?
state	DWORD	?
csname	DWORD	?
name_	DWORD	?
comment_	DWORD	?
dir	DWORD	?
mbminlen	DWORD	?
mbmaxlen	DWORD	?
MY_CHARSET_INFO	ends

MYSQL	struct 
	net	NET	<>
	connector_fd	dword	?
	host	DWORD	?
	user	DWORD	?
	passwd	DWORD	?
	unix_socket	DWORD	?
	server_version	DWORD	?
	host_info	DWORD	?
	info	DWORD	?
	database	DWORD	?
	charset DWORD ?
	fields	MYSQL_FIELD <>
	field_alloc	MEM_ROOT <>
	affected_rows	dword	?
	insert_id	dword	?
	extra_info	dword	?
	thread_id	DWORD	?
	packet_length	DWORD	?
	port	DWORD	?
	client_flag	DWORD	?
	server_capabilities	dword	?
	protocol_version	DWORD	?
	field_count	DWORD	?
	server_status	DWORD	?
	server_language	DWORD	?
	warning_count	DWORD	?
	options st_mysql_options <>
	status	mysql_status	?
	free_me	dword	?
	reconnect	dword	?
	scramble	SBYTE SCRAMBLE_LENGTH+1 dup (?)
	rpl_pivot	dword	?
	master DWORD ?
	next_slave	DWORD	?
	last_used_slave DWORD ?
	last_used_con DWORD ?
	stmts	LIST <>
	methods DWORD ?
	thd	DWORD	?
	unbuffered_fetch_owner	DWORD	?
	if defined(EMBEDDED_LIBRARY) OR defined(EMBEDDED_LIBRARY_COMPATIBLE) OR MYSQL_VERSION_ID ge 50100
		info_buffer	DWORD ?
	endif
MYSQL	ends

MYSQL_RES	struct 
	row_count	dword	?
	fields	MYSQL_FIELD <>
	data	MYSQL_DATA <>
	data_cursor	MYSQL_ROWS <>
	lengths	DWORD	?
	handle	MYSQL <>
	field_alloc	MEM_ROOT <>
	field_count	DWORD	?
	current_field	dword	?
	row	MYSQL_ROW ?
	current_row	MYSQL_ROW	?
	eof	dword	?
	unbuffered_fetch_cancelled	dword	?
	;methods DWORD ?
MYSQL_RES	ends

MAX_MYSQL_MANAGER_ERR	EQU	256
MAX_MYSQL_MANAGER_MSG	EQU	256
MANAGER_OK	EQU	200
MANAGER_INFO	EQU	250
MANAGER_ACCESS	EQU	401
MANAGER_CLIENT_ERR	EQU	450
MANAGER_INTERNAL_ERR	EQU	500
if 0 eq defined(MYSQL_SERVER) AND  0 eq defined(MYSQL_CLIENT)
MYSQL_CLIENT	EQU	<>
endif
 
MYSQL_MANAGER	struct 
	net	NET	<>
	host	DWORD	?
	user	DWORD	?
	passwd	DWORD	?
	port	DWORD	?
	free_me	dword	?
	eof	dword	?
	cmd_status	DWORD	?
	last_errno	DWORD	?
	net_buf	DWORD	?
	net_buf_pos	DWORD	?
	net_data_end	DWORD	?
	net_buf_size	DWORD	?
	last_error	SBYTE MAX_MYSQL_MANAGER_ERR dup (?)
MYSQL_MANAGER	ends

MYSQL_PARAMETERS	struct 
	p_max_allowed_packet	DWORD	?
	p_net_buffer_length	DWORD	?
MYSQL_PARAMETERS	ends

if 0 eq defined(MYSQL_SERVER) AND  0 eq defined(EMBEDDED_LIBRARY)
max_allowed_packet	EQU	( * mysql_get_parameters ( ) -> p_max_allowed_packet )
net_buffer_length	EQU	( * mysql_get_parameters ( ) -> p_net_buffer_length )
endif 

;mysql_server_init proto  :DWORD, :ptr ptr SBYTE, :ptr ptr SBYTE
;mysql_server_end proto  
;mysql_library_init	EQU	<mysql_server_init>
;mysql_library_end	EQU	<mysql_server_end>
;mysql_get_parameters proto  
;mysql_thread_init proto  
;mysql_thread_end proto  
;mysql_num_rows proto  :ptr MYSQL_RES
;mysql_num_fields proto  :ptr MYSQL_RES
;mysql_eof proto  :ptr MYSQL_RES
;mysql_fetch_field_direct proto  :ptr MYSQL_RES, :DWORD
;mysql_fetch_fields proto  :ptr MYSQL_RES
;mysql_row_tell proto  :ptr MYSQL_RES
;mysql_field_tell proto  :ptr MYSQL_RES
;mysql_field_count proto  :ptr MYSQL
;mysql_affected_rows proto  :ptr MYSQL
;mysql_insert_id proto  :ptr MYSQL
;mysql_errno proto  :ptr MYSQL
;mysql_error proto  :ptr MYSQL
;mysql_sqlstate proto  :ptr MYSQL
;mysql_warning_count proto  :ptr MYSQL
;mysql_info proto  :ptr MYSQL
;mysql_thread_id proto  :ptr MYSQL
;mysql_character_set_name proto  :ptr MYSQL
;mysql_set_character_set proto  :ptr MYSQL, :ptr SBYTE
;mysql_init proto  :ptr MYSQL
;mysql_ssl_set proto  :ptr MYSQL, :ptr SBYTE, :ptr SBYTE, :ptr SBYTE, :ptr SBYTE, :ptr SBYTE
;mysql_get_ssl_cipher proto  :ptr MYSQL
;mysql_change_user proto  :ptr MYSQL, :ptr SBYTE, :ptr SBYTE, :ptr SBYTE
;mysql_real_connect proto  :ptr MYSQL, :ptr SBYTE, :ptr SBYTE, :ptr SBYTE, :ptr SBYTE, :DWORD, :ptr SBYTE, :DWORD
;mysql_select_db proto  :ptr MYSQL, :ptr SBYTE
;mysql_query proto  :ptr MYSQL, :ptr SBYTE
;mysql_send_query proto  :ptr MYSQL, :ptr SBYTE, :DWORD
;mysql_real_query proto  :ptr MYSQL, :ptr SBYTE, :DWORD
;mysql_store_result proto  :ptr MYSQL
;mysql_use_result proto  :ptr MYSQL
;mysql_master_query proto  :ptr MYSQL, :ptr SBYTE, :DWORD
;mysql_master_send_query proto  :ptr MYSQL, :ptr SBYTE, :DWORD
;mysql_slave_query proto  :ptr MYSQL, :ptr SBYTE, :DWORD
;mysql_slave_send_query proto  :ptr MYSQL, :ptr SBYTE, :DWORD
;mysql_get_character_set_info proto  :ptr MYSQL, :ptr MY_CHARSET_INFO
LOCAL_INFILE_ERROR_LEN	EQU	512
;mysql_set_local_infile_handler proto  :ptr MYSQL, :ptr , :ptr , :ptr , :ptr , :ptr 
;mysql_set_local_infile_default proto  :ptr MYSQL
;mysql_enable_rpl_parse proto  :ptr MYSQL
;mysql_disable_rpl_parse proto  :ptr MYSQL
;mysql_rpl_parse_enabled proto  :ptr MYSQL
;mysql_enable_reads_from_master proto  :ptr MYSQL
;mysql_disable_reads_from_master proto  :ptr MYSQL
;mysql_reads_from_master_enabled proto  :ptr MYSQL
;STDCALL typedef DWORD
;mysql_rpl_query_type proto  :ptr SBYTE, :DWORD
;mysql_rpl_probe proto  :ptr MYSQL
;mysql_set_master proto  :ptr MYSQL, :ptr SBYTE, :DWORD, :ptr SBYTE, :ptr SBYTE
;mysql_add_slave proto  :ptr MYSQL, :ptr SBYTE, :DWORD, :ptr SBYTE, :ptr SBYTE
;mysql_shutdown proto  :ptr MYSQL, :mysql_enum_shutdown_level
;mysql_dump_debug_info proto  :ptr MYSQL
;mysql_refresh proto  :ptr MYSQL, :DWORD
;mysql_kill proto  :ptr MYSQL, :DWORD
;mysql_set_server_option proto  :ptr MYSQL, :enum_mysql_set_option
;mysql_ping proto  :ptr MYSQL
;mysql_stat proto  :ptr MYSQL
;mysql_get_server_info proto  :ptr MYSQL
;mysql_get_client_info proto  
;mysql_get_client_version proto  
;mysql_get_host_info proto  :ptr MYSQL
;mysql_get_server_version proto  :ptr MYSQL
;mysql_get_proto_info proto  :ptr MYSQL
;mysql_list_dbs proto  :ptr MYSQL, :ptr SBYTE
;mysql_list_tables proto  :ptr MYSQL, :ptr SBYTE
;mysql_list_processes proto  :ptr MYSQL
;mysql_options proto  :ptr MYSQL, :mysql_option, :ptr SBYTE
;mysql_free_result proto  :ptr MYSQL_RES
;mysql_data_seek proto  :ptr MYSQL_RES, :my_ulonglong
;mysql_row_seek proto  :ptr MYSQL_RES, :MYSQL_ROW_OFFSET
;mysql_field_seek proto  :ptr MYSQL_RES, :MYSQL_FIELD_OFFSET
;mysql_fetch_row proto  :ptr MYSQL_RES
;mysql_fetch_lengths proto  :ptr MYSQL_RES
;mysql_fetch_field proto  :ptr MYSQL_RES
;mysql_list_fields proto  :ptr MYSQL, :ptr SBYTE, :ptr SBYTE
;mysql_escape_string proto  :ptr SBYTE, :ptr SBYTE, :DWORD
;mysql_hex_string proto  :ptr SBYTE, :ptr SBYTE, :DWORD
;mysql_real_escape_string proto  :ptr MYSQL, :ptr SBYTE, :ptr SBYTE, :DWORD
;mysql_debug proto  :ptr SBYTE
;mysql_odbc_escape_string proto  :ptr MYSQL, :ptr SBYTE, :DWORD, :ptr SBYTE, :DWORD, :ptr , :ptr 
;myodbc_remove_escape proto  :ptr MYSQL, :ptr SBYTE
;mysql_thread_safe proto  
;mysql_embedded proto  
;mysql_manager_init proto  :ptr MYSQL_MANAGER
;mysql_manager_connect proto  :ptr MYSQL_MANAGER, :ptr SBYTE, :ptr SBYTE, :ptr SBYTE, :DWORD
;mysql_manager_close proto  :ptr MYSQL_MANAGER
;mysql_manager_command proto  :ptr MYSQL_MANAGER, :ptr SBYTE, :DWORD
;mysql_manager_fetch_line proto  :ptr MYSQL_MANAGER, :ptr SBYTE, :DWORD
;mysql_read_query_result proto  :ptr MYSQL
;enum_mysql_stmt_state typedef DWORD
MYSQL_STMT_INIT_DONE = 1 
MYSQL_STMT_PREPARE_DONE = 2
MYSQL_STMT_EXECUTE_DONE = 3
MYSQL_STMT_FETCH_DONE = 4

MYSQL_BIND	struct 
	length_	DWORD	?
	is_null	DWORD	?
	buffer	DWORD	?
	error	DWORD	?
	buffer_type	enum_field_types	?
	buffer_length	DWORD	?
	row_ptr	DWORD	?
	offset_	DWORD	?
	length_value	DWORD	?
	param_number	DWORD	?
	pack_length	DWORD	?
	error_value	dword	?
	is_unsigned	dword	?
	long_data_used	dword	?
	is_null_value	dword	?
	protoMYSQL_BIND_store_param_func typedef proto  :ptr NET,:ptr st_mysql_bind
	pMYSQL_BIND_store_param_func typedef ptr protoMYSQL_BIND_store_param_func
	store_param_func	pMYSQL_BIND_store_param_func	?
	protoMYSQL_BIND_fetch_result typedef proto  :ptr st_mysql_bind,:ptr MYSQL_FIELD,:ptr ptr unsigned
	pMYSQL_BIND_fetch_result typedef ptr protoMYSQL_BIND_fetch_result
	fetch_result	pMYSQL_BIND_fetch_result	?
	protoMYSQL_BIND_skip_result typedef proto  :ptr st_mysql_bind,:ptr MYSQL_FIELD,:ptr ptr unsigned
	pMYSQL_BIND_skip_result typedef ptr protoMYSQL_BIND_skip_result
	skip_result	pMYSQL_BIND_skip_result	?
MYSQL_BIND	ends

MYSQL_STMT	struct 
	mem_root	MEM_ROOT <>
	list	LIST <>
	mysql	MYSQL <>
	params	MYSQL_BIND <>
	_bind	MYSQL_BIND <>
	fields	MYSQL_FIELD <>
	result	MYSQL_DATA	<>
	data_cursor	MYSQL_ROWS <>
	affected_rows	dword	?
	insert_id	dword	?
	protoMYSQL_STMT_read_row_func typedef proto  :ptr st_mysql_stmt,:ptr ptr unsigned
	pMYSQL_STMT_read_row_func typedef ptr protoMYSQL_STMT_read_row_func
	read_row_func	pMYSQL_STMT_read_row_func	?
	stmt_id	DWORD	?
	flags	DWORD	?
	prefetch_rows	DWORD	?
	server_status	DWORD	?
	last_errno	DWORD	?
	param_count	DWORD	?
	field_count	DWORD	?
	state	dword	?
	last_error	SBYTE MYSQL_ERRMSG_SIZE dup (?)
	sqlstate	SBYTE SQLSTATE_LENGTH+1 dup (?)
	send_types_to_server	dword	?
	bind_param_done	dword	?
	bind_result_done	BYTE	?
	unbuffered_fetch_cancelled	dword	?
	update_max_length	dword	?
MYSQL_STMT	ends

enum_stmt_attr_type typedef DWORD
STMT_ATTR_UPDATE_MAX_LENGTH = 0
STMT_ATTR_CURSOR_TYPE = 1
STMT_ATTR_PREFETCH_ROWS = 2

MYSQL_METHODS	struct 
	protoMYSQL_METHODS_read_query_result typedef proto  :ptr MYSQL
	pMYSQL_METHODS_read_query_result typedef ptr protoMYSQL_METHODS_read_query_result
	read_query_result	pMYSQL_METHODS_read_query_result	?
	;protoMYSQL_METHODS_advanced_command typedef proto  :ptr MYSQL,:DWORD,:ptr SBYTE,:unsigned,:ptr SBYTE,:unsigned,:my_bool,:ptr MYSQL_STMT
	protoMYSQL_METHODS_advanced_command typedef proto  :ptr MYSQL,:DWORD,:ptr SBYTE,:unsigned,:ptr SBYTE,:unsigned,:DWORD,:ptr MYSQL_STMT
	pMYSQL_METHODS_advanced_command typedef ptr protoMYSQL_METHODS_advanced_command
	advanced_command	pMYSQL_METHODS_advanced_command	?
	protoMYSQL_METHODS_read_rows typedef proto  :ptr MYSQL,:ptr MYSQL_FIELD,:unsigned
	pMYSQL_METHODS_read_rows typedef ptr protoMYSQL_METHODS_read_rows
	read_rows	pMYSQL_METHODS_read_rows	?
	protoMYSQL_METHODS_use_result typedef proto  :ptr MYSQL
	pMYSQL_METHODS_use_result typedef ptr protoMYSQL_METHODS_use_result
	use_result	pMYSQL_METHODS_use_result	?
	protoMYSQL_METHODS_fetch_lengths typedef proto  :ptr unsigned,:MYSQL_ROW,:unsigned
	pMYSQL_METHODS_fetch_lengths typedef ptr protoMYSQL_METHODS_fetch_lengths
	fetch_lengths	pMYSQL_METHODS_fetch_lengths	?
	protoMYSQL_METHODS_flush_use_result typedef proto  :ptr MYSQL
	pMYSQL_METHODS_flush_use_result typedef ptr protoMYSQL_METHODS_flush_use_result
	flush_use_result	pMYSQL_METHODS_flush_use_result	?
	if 0 eq defined(MYSQL_SERVER) OR defined(EMBEDDED_LIBRARY)
		protoMYSQL_METHODS_list_fields typedef proto  :ptr MYSQL
		pMYSQL_METHODS_list_fields typedef ptr protoMYSQL_METHODS_list_fields
		list_fields	pMYSQL_METHODS_list_fields	?
		protoMYSQL_METHODS_read_prepare_result typedef proto  :ptr MYSQL,:ptr MYSQL_STMT
		pMYSQL_METHODS_read_prepare_result typedef ptr protoMYSQL_METHODS_read_prepare_result
		read_prepare_result	pMYSQL_METHODS_read_prepare_result	?
		protoMYSQL_METHODS_stmt_execute typedef proto  :ptr MYSQL_STMT
		pMYSQL_METHODS_stmt_execute typedef ptr protoMYSQL_METHODS_stmt_execute
		stmt_execute	pMYSQL_METHODS_stmt_execute	?
		protoMYSQL_METHODS_read_binary_rows typedef proto  :ptr MYSQL_STMT
		pMYSQL_METHODS_read_binary_rows typedef ptr protoMYSQL_METHODS_read_binary_rows
		read_binary_rows	pMYSQL_METHODS_read_binary_rows	?
		protoMYSQL_METHODS_unbuffered_fetch typedef proto  :ptr MYSQL,:ptr ptr SBYTE
		pMYSQL_METHODS_unbuffered_fetch typedef ptr protoMYSQL_METHODS_unbuffered_fetch
		unbuffered_fetch	pMYSQL_METHODS_unbuffered_fetch	?
		protoMYSQL_METHODS_free_embedded_thd typedef proto  :ptr MYSQL
		pMYSQL_METHODS_free_embedded_thd typedef ptr protoMYSQL_METHODS_free_embedded_thd
		free_embedded_thd	pMYSQL_METHODS_free_embedded_thd	?
		protoMYSQL_METHODS_read_statistics typedef proto  :ptr MYSQL
		pMYSQL_METHODS_read_statistics typedef ptr protoMYSQL_METHODS_read_statistics
		read_statistics	pMYSQL_METHODS_read_statistics	?
		protoMYSQL_METHODS_next_result typedef proto  :ptr MYSQL
		pMYSQL_METHODS_next_result typedef ptr protoMYSQL_METHODS_next_result
		next_result	pMYSQL_METHODS_next_result	?
		protoMYSQL_METHODS_read_change_user_result typedef proto  :ptr MYSQL,:ptr SBYTE,:ptr SBYTE
		pMYSQL_METHODS_read_change_user_result typedef ptr protoMYSQL_METHODS_read_change_user_result
		read_change_user_result	pMYSQL_METHODS_read_change_user_result	?
		protoMYSQL_METHODS_read_rows_from_cursor typedef proto  :ptr MYSQL_STMT
		pMYSQL_METHODS_read_rows_from_cursor typedef ptr protoMYSQL_METHODS_read_rows_from_cursor
		read_rows_from_cursor	pMYSQL_METHODS_read_rows_from_cursor	?
	endif 
MYSQL_METHODS	ends

;mysql_stmt_init proto  :ptr MYSQL
;mysql_stmt_prepare proto  :ptr MYSQL_STMT, :ptr SBYTE, :DWORD
;mysql_stmt_execute proto  :ptr MYSQL_STMT
;mysql_stmt_fetch proto  :ptr MYSQL_STMT
;mysql_stmt_fetch_column proto  :ptr MYSQL_STMT, :ptr MYSQL_BIND, :DWORD, :DWORD
;mysql_stmt_store_result proto  :ptr MYSQL_STMT
;mysql_stmt_param_count proto  :ptr MYSQL_STMT
;mysql_stmt_attr_set proto  :ptr MYSQL_STMT, :enum_stmt_attr_type, :ptr 
;mysql_stmt_attr_get proto  :ptr MYSQL_STMT, :enum_stmt_attr_type, :ptr 
;mysql_stmt_bind_param proto  :ptr MYSQL_STMT, :ptr MYSQL_BIND
;mysql_stmt_bind_result proto  :ptr MYSQL_STMT, :ptr MYSQL_BIND
;mysql_stmt_close proto  :ptr MYSQL_STMT
;mysql_stmt_reset proto  :ptr MYSQL_STMT
;mysql_stmt_free_result proto  :ptr MYSQL_STMT
;mysql_stmt_send_long_data proto  :ptr MYSQL_STMT, :DWORD, :ptr SBYTE, :DWORD
;mysql_stmt_result_metadata proto  :ptr MYSQL_STMT
;mysql_stmt_param_metadata proto  :ptr MYSQL_STMT
;mysql_stmt_errno proto  :ptr MYSQL_STMT
;mysql_stmt_error proto  :ptr MYSQL_STMT
;mysql_stmt_sqlstate proto  :ptr MYSQL_STMT
;mysql_stmt_row_seek proto  :ptr MYSQL_STMT, :MYSQL_ROW_OFFSET
;mysql_stmt_row_seek proto  :ptr MYSQL_STMT, :dword
;mysql_stmt_row_tell proto  :ptr MYSQL_STMT
;mysql_stmt_data_seek proto  :ptr MYSQL_STMT, :dword
;mysql_stmt_num_rows proto  :ptr MYSQL_STMT
;mysql_stmt_affected_rows proto  :ptr MYSQL_STMT
;mysql_stmt_insert_id proto  :ptr MYSQL_STMT
;mysql_stmt_field_count proto  :ptr MYSQL_STMT
;mysql_commit proto  :ptr MYSQL
;mysql_rollback proto  :ptr MYSQL
;mysql_autocommit proto  :ptr MYSQL, :dword
;mysql_more_results proto  :ptr MYSQL
;mysql_next_result proto  :ptr MYSQL
;mysql_close proto  :ptr MYSQL
MYSQL_NO_DATA	EQU	100
MYSQL_DATA_TRUNCATED	EQU	101

mysql_reload macro mysql
	exitm <mysql_refresh ( ( mysql ) , REFRESH_GRANT ) >
endm

ifdef USE_OLD_FUNCTIONS
	mysql_connect proto  :ptr MYSQL, :ptr SBYTE, :ptr SBYTE, :ptr SBYTE
	mysql_create_db proto  :ptr MYSQL, :ptr SBYTE
	mysql_drop_db proto  :ptr MYSQL, :ptr SBYTE
	mysql_reload macro mysql
		exitm <mysql_refresh ( ( mysql ) , REFRESH_GRANT ) >
	endm
endif
 
HAVE_MYSQL_REAL_CONNECT	EQU	<>

simple_command macro mysql,command,arg,length,skip_check
	exitm <( * ( mysql ) -> methods -> advanced_command ) ( mysql , command , NullS , 0 , arg , length , skip_check , NULL ) >
endm

stmt_command macro mysql,command,arg,length,stmt
	exitm <( * ( mysql ) -> methods -> advanced_command ) ( mysql , command , NullS , 0 , arg , length , 1 , stmt ) >
endm

;--- errors: 0
;--- end of file ---
