;--- include file created by h2incx v0.99.19 (copyright 2005-2006 japheth)
;--- source file: C:\MASM Projects\lij1\mysql_com.h, last modified: 1/18/2008 16:57
;--- cmdline used for creation: mysql_com.h

ifndef _mysql_com_h
_mysql_com_h	EQU	<>
NAME_LEN EQU 64
HOSTNAME_LENGTH	EQU	60
USERNAME_LENGTH	EQU	16
SERVER_VERSION_LENGTH EQU 60
SQLSTATE_LENGTH	EQU	5
USER_HOST_BUFF_SIZE	EQU	HOSTNAME_LENGTH + USERNAME_LENGTH + 2
LOCAL_HOST EQU <"localhost">
LOCAL_HOST_NAMEDPIPE EQU <".">

ifndef defined
defined macro x
ifdef x
  exitm <1>
else
  exitm <0>
endif
endm
endif

if defined(__WIN__) AND  0 eq defined(_CUSTOMCONFIG_)
	MYSQL_NAMEDPIPE	EQU	<"MySQL">
	MYSQL_SERVICENAME	EQU	<"MySQL">
endif
 
enum_server_command typedef DWORD
COM_SLEEP = 0
COM_QUIT = 1
COM_INIT_DB = 2
COM_QUERY = 3
COM_FIELD_LIST = 4
COM_CREATE_DB = 5
COM_DROP_DB = 6
COM_REFRESH = 7
COM_SHUTDOWN = 8
COM_STATISTICS = 9
COM_PROCESS_INFO = 10
COM_CONNECT = 11
COM_PROCESS_KILL = 12
COM_DEBUG = 13
COM_PING = 14
COM_TIME = 15
COM_DELAYED_INSERT = 16
COM_CHANGE_USER = 17
COM_BINLOG_DUMP = 18
COM_TABLE_DUMP = 19
COM_CONNECT_OUT = 20
COM_REGISTER_SLAVE = 21
COM_STMT_PREPARE = 22
COM_STMT_EXECUTE = 23
COM_STMT_SEND_LONG_DATA = 24
COM_STMT_CLOSE = 25
COM_STMT_RESET = 26
COM_SET_OPTION = 27
COM_STMT_FETCH = 28
COM_END = 29

SCRAMBLE_LENGTH	EQU	20
SCRAMBLE_LENGTH_323	EQU	8
SCRAMBLED_PASSWORD_CHAR_LENGTH	EQU	( SCRAMBLE_LENGTH * 2 + 1 )
SCRAMBLED_PASSWORD_CHAR_LENGTH_323	EQU	( SCRAMBLE_LENGTH_323 * 2 )
NOT_NULL_FLAG	EQU	1
PRI_KEY_FLAG	EQU	2
UNIQUE_KEY_FLAG	EQU	4
MULTIPLE_KEY_FLAG	EQU	8
BLOB_FLAG	EQU	16
UNSIGNED_FLAG	EQU	32
ZEROFILL_FLAG	EQU	64
BINARY_FLAG	EQU	128
ENUM_FLAG	EQU	256
AUTO_INCREMENT_FLAG	EQU	512
TIMESTAMP_FLAG	EQU	1024
SET_FLAG	EQU	2048
NO_DEFAULT_VALUE_FLAG	EQU	4096
NUM_FLAG	EQU	32768
PART_KEY_FLAG	EQU	16384
GROUP_FLAG	EQU	32768
UNIQUE_FLAG	EQU	65536
BINCMP_FLAG	EQU	131072
REFRESH_GRANT	EQU	1
REFRESH_LOG	EQU	2
REFRESH_TABLES	EQU	4
REFRESH_HOSTS	EQU	8
REFRESH_STATUS	EQU	16
REFRESH_THREADS	EQU	32
REFRESH_SLAVE	EQU	64
REFRESH_MASTER	EQU	128
REFRESH_READ_LOCK	EQU	16384
REFRESH_FAST	EQU	32768
REFRESH_QUERY_CACHE	EQU	65536
REFRESH_QUERY_CACHE_FREE	EQU	20000h
REFRESH_DES_KEY_FILE	EQU	40000h
REFRESH_USER_RESOURCES	EQU	80000h
CLIENT_LONG_PASSWORD	EQU	1
CLIENT_FOUND_ROWS	EQU	2
CLIENT_LONG_FLAG	EQU	4
CLIENT_CONNECT_WITH_DB	EQU	8
CLIENT_NO_SCHEMA	EQU	16
CLIENT_COMPRESS	EQU	32
CLIENT_ODBC	EQU	64
CLIENT_LOCAL_FILES	EQU	128
CLIENT_IGNORE_SPACE	EQU	256
CLIENT_PROTOCOL_41	EQU	512
CLIENT_INTERACTIVE	EQU	1024
CLIENT_SSL	EQU	2048
CLIENT_IGNORE_SIGPIPE	EQU	4096
CLIENT_TRANSACTIONS	EQU	8192
CLIENT_RESERVED	EQU	16384
CLIENT_SECURE_CONNECTION	EQU	32768
CLIENT_MULTI_STATEMENTS	EQU	( 1  shl  16 )
CLIENT_MULTI_RESULTS	EQU	( 1  shl  17 )
CLIENT_SSL_VERIFY_SERVER_CERT	EQU	( 1  shl  30 )
CLIENT_REMEMBER_OPTIONS	EQU	( 1  shl  31 )
SERVER_STATUS_IN_TRANS	EQU	1
SERVER_STATUS_AUTOCOMMIT	EQU	2
SERVER_MORE_RESULTS_EXISTS	EQU	8
SERVER_QUERY_NO_GOOD_INDEX_USED	EQU	16
SERVER_QUERY_NO_INDEX_USED	EQU	32
SERVER_STATUS_CURSOR_EXISTS	EQU	64
SERVER_STATUS_LAST_ROW_SENT	EQU	128
SERVER_STATUS_DB_DROPPED	EQU	256
SERVER_STATUS_NO_BACKSLASH_ESCAPES	EQU	512
MYSQL_ERRMSG_SIZE	EQU	512
NET_READ_TIMEOUT	EQU	30
NET_WRITE_TIMEOUT	EQU	60
NET_WAIT_TIMEOUT	EQU	8 * 60 * 60
ONLY_KILL_QUERY	EQU	1
;Vio typedef st_vio

MAX_TINYINT_WIDTH	EQU	3
MAX_SMALLINT_WIDTH	EQU	5
MAX_MEDIUMINT_WIDTH	EQU	8
MAX_INT_WIDTH	EQU	10
MAX_BIGINT_WIDTH	EQU	20
MAX_CHAR_WIDTH	EQU	255
MAX_BLOB_WIDTH	EQU	8192

NET	struct 
	if 0 eq defined(CHECK_EMBEDDED_DIFFERENCES) OR  0 eq defined(EMBEDDED_LIBRARY)
		vio	DWORD	?
		buff	DWORD	?
		buff_end	DWORD	?
		write_pos	DWORD	?
		read_pos	DWORD	?
		;fd	my_socket	?
		fd	dword	?
		max_packet	DWORD	?
		;max_packet_size	unsigned unsigned unsi	?
		max_packet_size	dword	?
		pkt_nr	DWORD	?
		;compress_pkt_nr	unsigned unsigned uns	?
		compress_pkt_nr	dword	?
		write_timeout	DWORD	?
		;read_timeout	unsigned unsigned uns	?
		;retry_count	unsigned unsigned unsigned uns	?
		read_timeout	dword	?
		retry_count	dword	?
		fcntl	DWORD	?
		;compress	my_bool	?
		compress	dword	?
		remain_in_buf	DWORD	?
		;length_	unsigned unsigned unsi	?
		;buf_length	unsigned unsigned unsigned unsi	?
		;where_b	unsigned unsigned unsigned unsigned unsi	?
		length_	dword	?
		buf_length	dword	?
		where_b	dword	?
		return_status	DWORD	?
		reading_or_writing	BYTE	?
		save_char	SBYTE	?
		;no_send_ok	my_bool	?
		;no_send_eof	my_bool	?
		;no_send_error	my_bool	?
		no_send_ok	dword	?
		no_send_eof	dword	?
		no_send_error	dword	?
	endif
	last_error	SBYTE MYSQL_ERRMSG_SIZE dup (?)
	sqlstate	SBYTE SQLSTATE_LENGTH+1 dup (?)
	last_errno	DWORD	?
	error	BYTE	?
	;query_cache_query	gptr	?
	;report_error	my_bool	?
	;return_errno	my_bool	?
	query_cache_query	dword	?
	report_error	dword	?
	return_errno	dword	?
NET	ends

packet_error	EQU	<(  not  ( unsigned long ) 0 )>
enum_field_types typedef DWORD
MYSQL_TYPE_DECIMAL = 0
MYSQL_TYPE_TINY = 1
MYSQL_TYPE_SHORT = 2
MYSQL_TYPE_LONG = 3
MYSQL_TYPE_FLOAT = 4
MYSQL_TYPE_DOUBLE = 5
MYSQL_TYPE_NULL = 6
MYSQL_TYPE_TIMESTAMP = 7
MYSQL_TYPE_LONGLONG = 8
MYSQL_TYPE_INT24 = 9
MYSQL_TYPE_DATE = 10
MYSQL_TYPE_TIME = 11
MYSQL_TYPE_DATETIME = 12
MYSQL_TYPE_YEAR = 13
MYSQL_TYPE_NEWDATE = 14
MYSQL_TYPE_VARCHAR = 15
MYSQL_TYPE_BIT = 16
MYSQL_TYPE_NEWDECIMAL = 246 
MYSQL_TYPE_ENUM = 247 
MYSQL_TYPE_SET = 248 
MYSQL_TYPE_TINY_BLOB = 249 
MYSQL_TYPE_MEDIUM_BLOB = 250 
MYSQL_TYPE_LONG_BLOB = 251 
MYSQL_TYPE_BLOB = 252 
MYSQL_TYPE_VAR_STRING = 253 
MYSQL_TYPE_STRING = 254 
MYSQL_TYPE_GEOMETRY = 255 

CLIENT_MULTI_QUERIES	EQU	<CLIENT_MULTI_STATEMENTS>
FIELD_TYPE_DECIMAL	EQU	<MYSQL_TYPE_DECIMAL>
FIELD_TYPE_NEWDECIMAL	EQU	<MYSQL_TYPE_NEWDECIMAL>
FIELD_TYPE_TINY	EQU	<MYSQL_TYPE_TINY>
FIELD_TYPE_SHORT	EQU	<MYSQL_TYPE_SHORT>
FIELD_TYPE_LONG	EQU	<MYSQL_TYPE_LONG>
FIELD_TYPE_FLOAT	EQU	<MYSQL_TYPE_FLOAT>
FIELD_TYPE_DOUBLE	EQU	<MYSQL_TYPE_DOUBLE>
FIELD_TYPE_NULL	EQU	<MYSQL_TYPE_NULL>
FIELD_TYPE_TIMESTAMP	EQU	<MYSQL_TYPE_TIMESTAMP>
FIELD_TYPE_LONGLONG	EQU	<MYSQL_TYPE_LONGLONG>
FIELD_TYPE_INT24	EQU	<MYSQL_TYPE_INT24>
FIELD_TYPE_DATE	EQU	<MYSQL_TYPE_DATE>
FIELD_TYPE_TIME	EQU	<MYSQL_TYPE_TIME>
FIELD_TYPE_DATETIME	EQU	<MYSQL_TYPE_DATETIME>
FIELD_TYPE_YEAR	EQU	<MYSQL_TYPE_YEAR>
FIELD_TYPE_NEWDATE	EQU	<MYSQL_TYPE_NEWDATE>
FIELD_TYPE_ENUM	EQU	<MYSQL_TYPE_ENUM>
FIELD_TYPE_SET	EQU	<MYSQL_TYPE_SET>
FIELD_TYPE_TINY_BLOB	EQU	<MYSQL_TYPE_TINY_BLOB>
FIELD_TYPE_MEDIUM_BLOB	EQU	<MYSQL_TYPE_MEDIUM_BLOB>
FIELD_TYPE_LONG_BLOB	EQU	<MYSQL_TYPE_LONG_BLOB>
FIELD_TYPE_BLOB	EQU	<MYSQL_TYPE_BLOB>
FIELD_TYPE_VAR_STRING	EQU	<MYSQL_TYPE_VAR_STRING>
FIELD_TYPE_STRING	EQU	<MYSQL_TYPE_STRING>
FIELD_TYPE_CHAR	EQU	<MYSQL_TYPE_TINY>
FIELD_TYPE_INTERVAL	EQU	<MYSQL_TYPE_ENUM>
FIELD_TYPE_GEOMETRY	EQU	<MYSQL_TYPE_GEOMETRY>
FIELD_TYPE_BIT	EQU	<MYSQL_TYPE_BIT>

MYSQL_SHUTDOWN_KILLABLE_CONNECT	EQU	( 1  shl  0 )
MYSQL_SHUTDOWN_KILLABLE_TRANS	EQU	( 1  shl  1 )
MYSQL_SHUTDOWN_KILLABLE_LOCK_TABLE	EQU	( 1  shl  2 )
MYSQL_SHUTDOWN_KILLABLE_UPDATE	EQU	( 1  shl  3 )

mysql_enum_shutdown_level typedef DWORD
SHUTDOWN_DEFAULT = 0 
SHUTDOWN_WAIT_CONNECTIONS = MYSQL_SHUTDOWN_KILLABLE_CONNECT 
SHUTDOWN_WAIT_TRANSACTIONS = MYSQL_SHUTDOWN_KILLABLE_TRANS 
SHUTDOWN_WAIT_UPDATES = MYSQL_SHUTDOWN_KILLABLE_UPDATE 
SHUTDOWN_WAIT_ALL_BUFFERS = ( MYSQL_SHUTDOWN_KILLABLE_UPDATE  shl  1 ) 
SHUTDOWN_WAIT_CRITICAL_BUFFERS = ( MYSQL_SHUTDOWN_KILLABLE_UPDATE  shl  1 ) + 1

if MYSQL_VERSION_ID ge 50000
KILL_QUERY = 254
endif
KILL_CONNECTION = 255

enum_cursor_type typedef DWORD
CURSOR_TYPE_NO_CURSOR = 0 
CURSOR_TYPE_READ_ONLY = 1 
CURSOR_TYPE_FOR_UPDATE = 2 
CURSOR_TYPE_SCROLLABLE = 4 

enum_mysql_set_option typedef DWORD
MYSQL_OPTION_MULTI_STATEMENTS_ON = 0
MYSQL_OPTION_MULTI_STATEMENTS_OFF = 1

net_new_transaction macro net
	exitm <( ( net ) -> pkt_nr = 0 ) >
endm

my_net_init proto  :ptr NET, :ptr Vio
my_net_local_init proto  :ptr NET
net_end proto  :ptr NET
net_clear proto  :ptr NET
net_realloc proto  :ptr NET, :DWORD
net_flush proto  :ptr NET
my_net_write proto  :ptr NET, :ptr SBYTE, :DWORD
net_write_command proto  :ptr NET, :BYTE, :ptr SBYTE, :DWORD, :ptr SBYTE, :DWORD
net_real_write proto  :ptr NET, :ptr SBYTE, :DWORD
my_net_read proto  :ptr NET
ifdef _global_h
my_net_set_write_timeout proto  :ptr NET, :uint
my_net_set_read_timeout proto  :ptr NET, :uint
endif 
;my_connect proto  :my_socket, :ptr sockaddr, :DWORD, :DWORD

rand_struct	struct 
	seed1 DWORD	?
	seed2 dword	?
	max_value dword	?
	max_value_dbl REAL8	?
rand_struct	ends

Item_result typedef DWORD
STRING_RESULT = 0 
REAL_RESULT = 1
INT_RESULT = 2
ROW_RESULT = 3
DECIMAL_RESULT = 4

UDF_ARGS struct 
	arg_count DWORD	?
	arg_type DWORD ?
	args DWORD ?
	lengths	DWORD ?
	maybe_null DWORD ?
	attributes DWORD ?
	attribute_lengths DWORD	?
UDF_ARGS ends

UDF_INIT struct 
	maybe_null dword ?
	decimals DWORD ?
	max_length DWORD ?
	Fptr DWORD ?	; /* free pointer for function data */
	const_item dword ?
UDF_INIT ends

NET_HEADER_SIZE	EQU	4
COMP_HEADER_SIZE EQU 3
;ifdef __cplusplus
;extern "C"
;{
;endif 
;randominit proto  :ptr rand_struct, :DWORD, :DWORD
;my_rnd proto  :ptr rand_struct
;create_random_string proto  :ptr SBYTE, :DWORD, :ptr rand_struct
;hash_password proto  :ptr DWORD, :ptr SBYTE, :DWORD
;make_scrambled_password_323 proto  :ptr SBYTE, :ptr SBYTE
;scramble_323 proto  :ptr SBYTE, :ptr SBYTE, :ptr SBYTE
;check_scramble_323 proto  :ptr SBYTE, :ptr SBYTE, :ptr DWORD
;get_salt_from_password_323 proto  :ptr DWORD, :ptr SBYTE
;make_password_from_salt_323 proto  :ptr SBYTE, :ptr DWORD
;make_scrambled_password proto  :ptr SBYTE, :ptr SBYTE
;scramble proto  :ptr SBYTE, :ptr SBYTE, :ptr SBYTE
;check_scramble proto  :ptr SBYTE, :ptr SBYTE, :ptr BYTE
;get_salt_from_password proto  :ptr BYTE, :ptr SBYTE
;make_password_from_salt proto  :ptr SBYTE, :ptr BYTE
;octet2hex proto  :ptr SBYTE, :ptr SBYTE, :DWORD
;get_tty_password proto  :ptr SBYTE
;mysql_errno_to_sqlstate proto  :DWORD
;my_init proto  
;modify_defaults_file proto  :ptr SBYTE, :ptr SBYTE, :ptr SBYTE, :ptr SBYTE, :DWORD
;load_defaults proto  :ptr SBYTE, :ptr ptr SBYTE, :ptr DWORD, :ptr ptr ptr SBYTE
;my_thread_init proto  
;my_thread_end proto  
ifdef _global_h
net_field_length proto  :ptr ptr uchar
net_field_length_ll proto  :ptr ptr uchar
net_store_length proto  :ptr SBYTE, :ulonglong
endif 
ifdef __cplusplus
;}
endif 
NULL_LENGTH	EQU	<( ( unsigned long )  not  0 )>
MYSQL_STMT_HEADER	EQU	4
MYSQL_LONG_DATA_HEADER	EQU	6
endif 

;--- errors: 0
;--- end of file ---
